﻿"""
Måste göras
............
Mäta i rätt ordning
Original pålen får inte sluta med .1 .2 eller .3
"""
#region Reference stuff

import clr
import types
import math
import os
import copy

from winreg import *




clr.AddReference('IronPython.Wpf')
import wpf
import datetime
import random
import string
import re
from random import *




from System.Collections.Generic import List
from System.Windows import Window, MessageBox, MessageBoxResult, MessageBoxButton, Visibility
from System.Windows.Controls import StackPanel, Button, CheckBox
from System.Windows.Input import Keyboard, AccessKeyManager, Key
from System import Type, Tuple, Array, Double, String
from System.IO import StreamReader, MemoryStream, Path, File

clr.AddReference("System.Drawing")
from System.Drawing import Bitmap
clr.AddReference("System.Windows.Forms")
from System.Windows.Forms import Control, Keys, OpenFileDialog, SaveFileDialog
clr.AddReference("Trimble.Vce.UI.BaseCommands")
from Trimble.Vce.UI.BaseCommands import SelectionContextMenuHandler, SelectPointsCmd
clr.AddReference("Trimble.Sdk.ForeignCad")
from Trimble.Vce.ForeignCad import TextEntity, MText, Text, Leader, Point
clr.AddReference("Trimble.Sdk.Geometry")
from Trimble.Vce.Geometry.PolySeg import PolySeg
clr.AddReference("Trimble.Sdk.Interfaces")
from Trimble.Vce.Interfaces.SnapIn import ISnapIn, IPolyseg, IHaveUcs, IMemberManagement, IName
from Trimble.Vce.Interfaces.Point import IPoint, IPointLocation, IFeatureCodeParent
from Trimble.Vce.Interfaces.Client import CommandGranularity, IProject, IProjectGetter
clr.AddReference("Trimble.Vce.UI.Controls")
from Trimble.Vce.UI.Controls import VceMessageBox, AngularEdit, BrowseFile, SelectEntity
clr.AddReference("Trimble.Sdk.DiskIO")
from Trimble.DiskIO import SearchPath
clr.AddReference("Trimble.Sdk.Coordinates")
from Trimble.Vce.Coordinates import CoordinateData, EnabledStatus, ICoordinate, ICoordinateAccess
from Trimble.Vce.Core import GlobalSelection

from Trimble.Vce.Coordinates import Point as CoordPoint

#exempel 1
from Trimble.Vce.Geometry import Point3D


from Trimble.Vce.Coordinates import PointCollection, NEECoordinate, Point
from Trimble.Vce.Interfaces import Client, Point as PointHelper, FeatureCoding



# #Exempel_tva
# clr.AddReference("Trimble.Vce.Coordinates")
# from Trimble.Vce.Coordinates import PointCollection, NEECoordinate, Point
# clr.AddReference("Trimble.Vce.Interfaces")
# from Trimble.Vce.Interfaces import Client, Point as PointHelper, FeatureCoding

from Trimble.Vce.Data.RawData import PointManager





def Setup(cmdData, macroFileFolder):
    cmdData.Key = "palar2"
    cmdData.CommandName = "palar2"
    cmdData.Caption = "_Palar Inmätning V1.0"
    cmdData.UIForm = "palar2" # MUST MATCH NAME FROM CLASS DEFINED BELOW !!!

    # if you are going to include a help file, define file and topic id here
    cmdData.HelpFile = "MyMacros.chm"
    cmdData.HelpTopic = "xxxx"
    # Version 5.10 has macro version support
    try:
        cmdData.DefaultTabKey = "Macros"
        cmdData.DefaultTabGroupKey = "Trimtec"
        cmdData.ShortCaption = "Pålar inmätning"
        cmdData.DefaultRibbonToolSize = 3 # Default=0, ImageOnly=1, Normal=2, Large=3
        cmdData.Version = 1.0
        cmdData.MacroAuthor = "Trimtec..."
        cmdData.MacroInfo = r""
    except:
        pass

    # # if you want the macro included in the ribbon, fill in the following 5 lines
    # cmdData.DefaultTabKey = "Macros"
    # cmdData.DefaultTabGroupKey = "MyStuff"
    # cmdData.ShortCaption = "Palar2 macro"
    cmdData.ToolTipTittle = "Pålar inmätning"
    cmdData.ToolTipTextFormatted = "Beräkna centriskt eller excentriskt inmätta pålar"
    try:
        b = Bitmap(macroFileFolder + "\\" + cmdData.Key + ".png")
        cmdData.ImageSmall = b
    except:
        pass

# the name of this class must match name from cmdData.UIForm (above)
class palar2(StackPanel): # this inherits from the WPF StackPanel control
    #VceMessageBox.Show("tests")
    def __init__(self, currentProject, macroFileFolder):
        with StreamReader(macroFileFolder + r"\palar2.xaml") as s:
            wpf.LoadComponent(self, s)

        self.currentProject = currentProject
        self.tType = clr.GetClrType(TextEntity)
        self.lType = clr.GetClrType(IPolyseg)
        self.pType = clr.GetClrType(IPoint)
        self.ptType = clr.GetClrType(IPointLocation)
        self.fcType = clr.GetClrType(IFeatureCodeParent)


        self.pxy = []
        self.sorteradArray = []
        self.lineArray = []
        self.listSerials = []
        self.tusen = 1
        self.felNum = 0


        self.lutningInst = None
        self.baringInst = None
        self.lutRapInst = None
        self.deciInst = None
        self.barRapInst = None
        self.avstandTalerans = None



    def OnLoad(self, cmd, buttons, event):
        optionMenu = SelectionContextMenuHandler()
        optionMenu.ExcludedCommands = "SelectObservations | SelectPoints | SelectDuplicatePoints"
        self.objs.ButtonContextMenu = optionMenu



    def CancelClicked(self, sender, e):
        self.lutningInst = None
        self.baringInst = None
        self.lutRapInst = None
        self.deciInst = None
        self.barRapInst = None
        self.avstandTalerans = None
        self.felNum = 0



        sender.CloseUICommand()



    def OkClicked(self, sender, e):

        settingsOk = True

        #Kontrollerar att inställningar är OK
        if self.inmObj.Text == "" or self.deciObj.Text == "" or self.lutObj.Text == "" or self.barObj.Text == "":
            settingsOk = False

        #Kollar om toleransen är rätt format
        try:
            #Kollar om float
            self.avstandTalerans = float(self.avsTol.Text)
        except:
            #Om inte float, kollar om tom annars felmeddelande.
            if self.avsTol.Text == "":
                self.avstandTalerans = self.avsTol.Text
            else:
                VceMessageBox.ShowWarning("Felaktigt värdet för toleransen")
                settingsOk = False


        if settingsOk == True:
            #Körs om inställningar är OK

            #0 sätter globala variabler med inställningar som anv. längre fram
            self.lutningInst = self.lutObj.Text
            self.baringInst = self.barObj.Text
            # self.lutRapInst = self.lutRapObj.Text
            self.deciInst = self.deciObj.Text
            # self.barRapInst = self.barRapObj.Text
            self.felNum = 0

            #1 - SKAPAR en lista med punkterna i projektet
            selectedPointsObj = self.createListSelectedObjects() #NEE

            if self.inmObj.Text == "Excentriskt":

                #2 - Delar upp inmätta och eventuella teoretiska PAP punkter (Return == DICT + LIST)
                foundInmPointsDict, foundRemPointsList = self.findCorespondinPointsExc(selectedPointsObj)

                #3 - Kollar om de inmätta punkterna heter .1 .2 .3  (Return == DICT)
                foundCorPoints = self.checkPointsExc(foundInmPointsDict)
                #4 - EXCENTRISKT - Skapar en lista med punkter på ny plats med Z tagen från teoretisk PAP (Return == LIST)
                calcPapPoints = self.calculatedPapExc(foundCorPoints, foundRemPointsList) #calcAlgPap

                #5 Gör om till rätt inställning i des1 och Des2 m.m.
                calcPapPointsNewDes = self.changeDesOneTwo(calcPapPoints)


                #kollar att inget fel vid transformationen av des1 och des2 m.m.
                if self.lutBarStatus == "ERR":
                    self.lutBarStatus = "OK"
                    VceMessageBox.ShowWarning("Kontrollera dina värden eller inställningar")
                else:
                    #Om inget fel - skapar punkterna
                    for key, dictItem in calcPapPointsNewDes.items():
                        #skapar punkterna i dicten
                        self.createNewPoint(dictItem)

                    #Rapport
                    try:
                        #Skapar info till rapport
                        dictRapport = self.skapaListTillRapport(calcPapPointsNewDes, foundRemPointsList)
                        #skapar rapporten som CSV och öppnar i excell alt. notepad
                        self.skaparCsvExcel(dictRapport)
                    except:
                        VceMessageBox.ShowWarning("Kontrollera dina värden eller inställningar")







            if self.inmObj.Text == "Centriskt":


                #2 - Delar upp inmätta och eventuella teoretiska PAP punkter (Return == DICT + LIST)
                foundInmPointsDict, foundRemPointsList = self.findCorespondinPointsExc(selectedPointsObj)

                #3 - Kollar om de inmätta punkterna heter .1 .2  (Return == DICT)
                foundCorPoints = self.checkPointsCent(foundInmPointsDict)
                #4 - EXCENTRISKT - Skapar en lista med punkter på ny plats med Z tagen från teoretisk PAP (Return == LIST)
                calcPapPoints = self.calculatedPapCent(foundCorPoints, foundRemPointsList) #calcAlgPap
                #5 Gör om till rätt inställning i des1 och Des2
                calcPapPointsNewDes = self.changeDesOneTwo(calcPapPoints)

                #kollar att inget fel vid transformationen av des1 och des2
                if self.lutBarStatus == "ERR":
                    self.lutBarStatus = "OK"
                    VceMessageBox.ShowWarning("Kontrollera dina värden eller inställningar")
                else:
                    #Om inget fel - skapar punkterna
                    for key, dictItem in calcPapPointsNewDes.items():
                        #skapar punkterna i dicten
                        self.createNewPoint(dictItem)

                    #Rapport
                    try:
                        #Skapar info till rapport
                        dictRapport = self.skapaListTillRapport(calcPapPointsNewDes, foundRemPointsList)
                        #skapar rapporten som CSV och öppnar i excell alt. notepad
                        self.skaparCsvExcel(dictRapport)
                    except:
                        VceMessageBox.ShowWarning("Kontrollera dina värden eller inställningar")

        else:
            #Felmedelande om fel inställnigar på pållängd
            self.lutningInst = None
            self.baringInst = None
            self.lutRapInst = None
            self.deciInst = None
            self.barRapInst = None
            self.avstandTalerans = None
            VceMessageBox.ShowWarning("Kontrollera dina värden eller inställningar")

        if settingsOk == True:
            #Rensar globala variabler och avslutar MACROT när klart.
            self.lutningInst = None
            self.baringInst = None
            self.lutRapInst = None
            self.deciInst = None
            self.barRapInst = None
            self.avstandTalerans = None
            self.felNum = 0


            sender.CloseUICommand()





    def skapaListTillRapport(self, dictBerPapPt, listRemPt):

        #Skapar en dict där skapade pnktera skapas
        dictDeltaPoints = {}

        #itterates trough points with berPapPoints
        for key, dictItem in dictBerPapPt.items():
            #looks if Teoretical point availible to compare
            decimalerInt = self.getDecimalPlaces()
            for remPt in listRemPt:
                #if it finds cor. point
                if str(key) == str(remPt.Namn):
                    tempDeltaPoint = types.SimpleNamespace()


                    #namnet
                    tempDeltaPoint.Namn = dictBerPapPt[key].Namn

                    #Teoretiska punkter
                    tempDeltaPoint.OriginalN = str(remPt.N)
                    tempDeltaPoint.OriginalE = str(remPt.E)
                    tempDeltaPoint.OriginalZ = str(remPt.Z)

                    #radiell
                    radielltAvst = math.sqrt((float(remPt.E)-float(dictBerPapPt[key].E))**2 + (float(remPt.N)-float(dictBerPapPt[key].N))**2)
                    radielltAvstrounded = self.getRoundedFloat(float(radielltAvst), decimalerInt)
                    tempDeltaPoint.radAvst = str(radielltAvstrounded)

                    #radiell inom tolerans?
                    if self.avstandTalerans == "":
                        tempDeltaPoint.avsTolerans = "-"
                    else:
                        if float(self.avstandTalerans) >= radielltAvst:
                            tempDeltaPoint.avsTolerans = "OK"
                        else:
                            tempDeltaPoint.avsTolerans = "UTANFÖR"

                    #Full
                    tempDeltaPoint.FullN = str(dictBerPapPt[key].N)
                    tempDeltaPoint.FullE = str(dictBerPapPt[key].E)
                    tempDeltaPoint.FullZ = str(dictBerPapPt[key].Z)

                    #Rounded
                    roundNorth = self.getRoundedFloat(float(dictBerPapPt[key].N), decimalerInt)
                    tempDeltaPoint.N = str(roundNorth)
                    roundEast = self.getRoundedFloat(float(dictBerPapPt[key].E), decimalerInt)
                    tempDeltaPoint.E = str(roundEast)
                    roundZedd = self.getRoundedFloat(float(dictBerPapPt[key].Z), decimalerInt)
                    tempDeltaPoint.Z = str(roundZedd)


                    #beräknar och avrundar
                    tempDeltaN = float(dictBerPapPt[key].N) - float(remPt.N)
                    roundDeltaN = self.getRoundedFloat(tempDeltaN, decimalerInt)
                    tempDeltaPoint.DeltaN = str(roundDeltaN)

                    #beräknar och avrundar
                    tempDeltaE = float(dictBerPapPt[key].E) - float(remPt.E)
                    roundDeltaE = self.getRoundedFloat(tempDeltaE, decimalerInt)
                    tempDeltaPoint.DeltaE = roundDeltaE

                    #beräknar och avrundar
                    tempDeltaZ = float(dictBerPapPt[key].Z) - float(remPt.Z)
                    roundDeltaZ = self.getRoundedFloat(tempDeltaZ, decimalerInt)
                    tempDeltaPoint.DeltaZ = roundDeltaZ

                    #Redan avrundat
                    # roundDes1 = self.getRoundedFloat(float(dictBerPapPt[key].Des1), decimalerInt)
                    tempDeltaPoint.Des1 = str(dictBerPapPt[key].Des1)

                    # roundDes2 = self.getRoundedFloat(float(dictBerPapPt[key].Des2), decimalerInt)
                    tempDeltaPoint.Des2 = str(dictBerPapPt[key].Des2)

                    dictDeltaPoints[remPt.Namn] = tempDeltaPoint

        return dictDeltaPoints




    def get_random_string(self, length):
        result_str = randint(1, length)
        return str(result_str)



    def skaparCsvExcel(self, dictRap):
        #Hämtar separatorn i windows inställningar så att CSV visas korrekt
        aReg = ConnectRegistry(None, HKEY_CURRENT_USER)
        aKey = OpenKey(aReg, r"Control Panel\International")
        valSysSeparator = QueryValueEx(aKey, "sList")[0]


        filename = os.path.expanduser('~/Downloads/Palar-rapport.csv')
        if File.Exists(filename):
                try:
                    File.Delete(filename)
                except:
                    randStr = self.get_random_string(999999999)
                    PathNameRand = "~/Downloads/Palar-rapport-#"+str(randStr)+".csv"
                    filename = os.path.expanduser(str(PathNameRand))

        #Skapar info för header i CSV
        if self.lutningInst == "Lutningsförhållande":
            lutSymbol = "sförhållande"
        if self.lutningInst == "Lutningsvinklar grader":
            lutSymbol = "(°)"
        if self.lutningInst == "Lutningsvinklar gon":
            lutSymbol = "(gon)"
        if self.lutningInst == "Lutning procent":
            lutSymbol = "(%)"
        if self.baringInst == "Grader":
            barSymbol = "(°)"
        if self.baringInst == "Gon":
            barSymbol = "(gon)"

        if self.avstandTalerans == "":
            avsTolSymb = "( - )"
        else:
            decimalerInt = self.getDecimalPlaces()
            roundedValTolerans = self.getRoundedFloat(float(self.avstandTalerans), decimalerInt)
            avsTolSymb = "( "+str(roundedValTolerans)+"m )"

        with open(filename, 'w') as f:
            #Skapar header i CSV
            if self.lutningInst:
                pass
            f.write("#Påle"+str(valSysSeparator))
            f.write("Northing(X)"+str(valSysSeparator))
            f.write("Easting(Y)"+str(valSysSeparator))
            f.write("Elevation(Z)"+str(valSysSeparator))
            f.write("Delta-X"+str(valSysSeparator))
            f.write("Delta-Y"+str(valSysSeparator))
            f.write("Avstånd"+str(valSysSeparator))
            f.write("Tolerans"+str(avsTolSymb)+str(valSysSeparator))
            f.write("Lutning"+str(lutSymbol)+str(valSysSeparator))
            f.write("Bäring"+str(barSymbol)+str(valSysSeparator))

            f.write("\n")
            #Skapar lista med alla punkterna
            for key, valDict in dictRap.items():
                # VceMessageBox.Show(str(valDict))
                f.write(str(key)+str(valSysSeparator))
                f.write(str(valDict.N)+str(valSysSeparator))
                f.write(str(valDict.E)+str(valSysSeparator))
                f.write(str(valDict.Z)+str(valSysSeparator))
                f.write(str(valDict.DeltaN)+str(valSysSeparator))
                f.write(str(valDict.DeltaE)+str(valSysSeparator))
                f.write(str(valDict.radAvst)+str(valSysSeparator))
                f.write(str(valDict.avsTolerans)+str(valSysSeparator))
                f.write(str(valDict.Des1)+str(valSysSeparator))
                f.write(str(valDict.Des2)+str(valSysSeparator))
                f.write("\n")

        #Öppnar CSV i Exell eller notepad
        try:
            os.system('start excel.exe "%s"' % (filename,))
        except:
            os.system('start notepad.exe "%s"' % (filename,))



    #göra om inclinationen(dec1) från tex procent till grader
    def inclTillGrader(self, pt):
        inclination = str(pt.Des1)
        inclination_degrees = "ERR"

        if self.lutningInst == "Lutningsförhållande":
            inclination = str(inclination)
            if ":" in inclination:
                a, b = map(float, inclination.split(":"))
                # Calculate the slope ratio as a float
                inclination = a / b

                # Calculate the angle in degrees
                radians = math.atan(inclination)
                degrees = math.degrees(radians)

                inclination_degrees = float(degrees)
            elif "/" in inclination:
                a, b = map(float, inclination.split("/"))
                # Calculate the slope ratio as a float
                inclination = a / b

                # Calculate the angle in degrees
                radians = math.atan(inclination)
                degrees = math.degrees(radians)

                inclination_degrees = float(degrees)
            else:
                inclination_degrees = "ERR"

        if self.lutningInst == "Lutningsvinklar grader":
            #gör INGET
            inclination_degrees = float(inclination)

        if self.lutningInst == "Lutningsvinklar gon":
            #gör om Lutningsvinklar grader till grader
            inclination_degrees = float(inclination)*(360/400)

        if self.lutningInst == "Lutning procent":
            #gör om Lutning procent grader till grader
            inclination = str(inclination)
            if "%" in inclination:
                inclination = inclination.replace("%","")
                inclination = inclination.replace(" ","")

            inclination = float(inclination)
            # Convert the percent slope to a decimal
            slope_decimal = inclination / 100

            # Calculate the angle in degrees using the arctan function
            degrees = math.degrees(math.atan(slope_decimal))

            inclination_degrees = float(degrees)

        return inclination_degrees

    #Gör om bäringen till grader(från tex gon till grader)
    def bearTillGrader(self, pt):
        #gör om Bäring till grader
        bearing = pt.Des2
        bearing_degrees = "ERR"


        #gör om BARING till grader
        if self.baringInst == "Grader":
            #gör INGET

            bearing_degrees = float(bearing)

        if self.baringInst == "Gon":
            #görom till grader
            bearing_degrees = float(bearing)*(360/400)


        return bearing_degrees


    #2 - Delar upp inmätta och eventuella teoretiska PAP punkter (Return == DICT + LIST)
    def findCorespondinPointsExc(self, pointObjekts):
        my_points = {}
        remaining_points = []

        for ptobj in pointObjekts:
            if len(ptobj.Namn) >= 2:
                try:
                    # Try to convert the value to an integer
                    sistaInt = int(ptobj.Namn[-1])
                    if ptobj.Namn[-2] == "." and type(sistaInt) is int and sistaInt <= 3 and sistaInt >= 1:
                        #PALE INMATT RATT
                        except_last_two = ptobj.Namn[:-2]

                        if except_last_two not in my_points:
                            # Create the variable if it doesn't exist
                            my_points[except_last_two] = [ptobj]
                        else:
                            # Create the variable if it doesn't exist
                            my_points[except_last_two].append(ptobj)
                    else:
                        #PALRE INMATT FEL ELLER TEORETISKA PELARNA
                        remaining_points.append(ptobj)

                except ValueError:
                    #filtrerar bort eventuella tidigare beräknade punkter
                    #som slutar med -ber
                    ifBerVal = str(ptobj.Namn[-4:])
                    if ifBerVal == "-ber":
                        pass
                    else:
                        remaining_points.append(ptobj)
            else:
                remaining_points.append(ptobj)

        return my_points, remaining_points

    #2 - SKAPAR en lista med punkterna i projektet
    def findCorespondinPointsCent(self, pointObjekts):
        my_points = {}
        remaining_points = []

        for ptobj in pointObjekts:
            if len(ptobj.Namn) >= 2:
                try:
                    # Try to convert the value to an integer
                    sistaInt = int(ptobj.Namn[-1])
                    if ptobj.Namn[-2] == "." and type(sistaInt) is int and sistaInt <= 2 and sistaInt >= 1:
                        #PALE INMATT RATT
                        except_last_two = ptobj.Namn[:-2]

                        if except_last_two not in my_points:
                            # Create the variable if it doesn't exist
                            my_points[except_last_two] = [ptobj]
                        else:
                            # Create the variable if it doesn't exist
                            my_points[except_last_two].append(ptobj)
                    else:
                        #PALRE INMATT FEL ELLER TEORETISKA PELARNA
                        remaining_points.append(ptobj)

                except ValueError:
                    pass


            else:
                pass

        return my_points, remaining_points


    #3 - Kollar om de inmätta punkterna heter .1 .2 .3  (Return == DICT)
    def checkPointsExc(self, foundCoPts):
        #Checks and filters out so object contains 3 points

        filteredDict = {}

        for key, dictItem in foundCoPts.items():

            if len(foundCoPts[key]) > 3:
                self.felNum = 1
            if len(foundCoPts[key]) == 3:
                filteredDict[key] = foundCoPts[key]
            else:
                pass




        return filteredDict


    def checkPointsCent(self, foundCoPts):
        #Checks and filters out so object contains 3 points

        filteredDict = {}

        for key, dictItem in foundCoPts.items():

            if len(foundCoPts[key]) > 2:
                self.felNum = 1
            if len(foundCoPts[key]) == 2:
                filteredDict[key] = foundCoPts[key]
            else:
                pass




        return filteredDict

    #4 - EXCENTRISKT - Skapar en lista med punkter på ny plats med Z tagen från teoretisk PAP (Return == LIST)
    def calculatedPapExc(self, dictCorPoints, listNonCorPts):

        dictCalcPoints = {}

        for key, value in dictCorPoints.items():


            p1 = types.SimpleNamespace()
            p2 = types.SimpleNamespace()
            p3 = types.SimpleNamespace()
            for val in value:



                if int(val.Namn[-1]) == 1:
                    p1 = val

                if int(val.Namn[-1]) == 2:
                    p2 = val

                if int(val.Namn[-1]) == 3:
                    p3 = val

            #calculate new point and bearing using XYZ of 3p
            newPapPoint = self.calcAlgPapExc(p1,p2,p3, listNonCorPts)
            if isinstance(newPapPoint, str):

                VceMessageBox.ShowWarning("Fel har uppstått!\nKontrollera höjderna samt teoretiska punkterna")
            else:
                dictCalcPoints[key] = newPapPoint


        return dictCalcPoints


    def calculatedPapCent(self, dictCorPoints, listNonCorPts):
        #1 - SKAPAR en lista med punkterna i projektet

        dictCalcPoints = {}


        for key, value in dictCorPoints.items():


            p1 = types.SimpleNamespace()
            p2 = types.SimpleNamespace()

            for val in value:



                if int(val.Namn[-1]) == 1:
                    p1 = val


                if int(val.Namn[-1]) == 2:
                    p2 = val





            #calculate new point and bearing using XYZ of 3p


            newPapPoint = self.calcAlgPapCent(p1,p2, listNonCorPts)
            if isinstance(newPapPoint, str):

                VceMessageBox.ShowWarning("Fel har uppstått!\nKontrollera höjderna samt teoretiska punkterna")
            else:
                dictCalcPoints[key] = newPapPoint


        return dictCalcPoints
            # OBS!!!! kontrollera om retur OK





        #Lutning
        # inclination = self.calcInclination(p1, p2)
        # if inclination == "err":
        #     status = "err"

        # #bäring
        # bearingDeg = self.calcBearing(p1, p2)
        # if bearingDeg == "err":
        #     status = "err"


        # incl, bear = self.calcBearingIncl(p1, p2)
        #
        # testPoint = self.calcPtInclBear()



        #OBS kontrollera om någon är ERR isf return ERR och ge meddelande

        #Slutligen kontrollera lutning och bäring inställningar och ändra

    def calcAlgPapExc(self, p1, p2, p3, listNonCorPts):
        #algoritm för att räkna ut PAP och bearing samt lutning
        status = ""


        #Beräknar bearing och Incl mellan P1 och P2
        bearing, inclination = self.calcBearingIncl(p1, p2)






        # Flyttar P3 till samma höjd som P1 mha incl. och bearing
        newZpoint3 = self.newPtWithInclBearNewZ(p3, inclination, bearing, float(p1.Z))
        # VceMessageBox.ShowWarning(str(newZpoint3))


        #Flyttar punkten mellan P1 och p3
        midPoint = self.calcMidPt2d(p1, newZpoint3)


        #Hittar teoretisk PAP och hämtar Z
        corPapPtZ = self.findCorPapElevation(midPoint.Namn[:-4],listNonCorPts)



        #Kontrollerar om den fanns
        if isinstance(corPapPtZ, float):
            #Beräknar punkten med PAP Z
            midPoint.Namn = midPoint.Namn[:-2]

            #Gör neg. till pos innan DES1 anges
            midPoint.Des1 = str(inclination)
            midPoint.Des1pos = str(abs(inclination)) #ASD
            midPoint.Des2 = str(bearing)
            midPoint.Des2pos = str(abs(bearing)) #ASD

            midPointPapZ = self.newPtWithInclBearNewZ(midPoint, inclination, bearing, corPapPtZ)
            return midPointPapZ

        else:
            return corPapPtZ


    def calcAlgPapCent(self, p1, p2, listNonCorPts):
        #algoritm för att räkna ut PAP och bearing samt lutning
        status = ""


        #Beräknar bearing och Incl mellan P1 och P2
        bearing, inclination = self.calcBearingIncl(p1, p2)

        #letar upp cor. punkt i ovriga punkter
        corPapPtZ = self.findCorPapElevation(p2.Namn[:-2],listNonCorPts)


        #Kontrollerar om den fanns
        if isinstance(corPapPtZ, float):
            #Beräknar punkten med PAP Z
            p2.Namn = p2.Namn


            #Gör neg. till pos innan DES1 anges
            p2.Des1 = str(inclination)
            p2.Des1pos = str(abs(inclination)) #ASD
            p2.Des2 = str(bearing)
            p2.Des2pos = str(abs(bearing)) #ASD

            newPointPapZ = self.newPtWithInclBearNewZ(p2, inclination, bearing, corPapPtZ)
            return newPointPapZ

        else:
            return corPapPtZ # skickar vidare error meddeande


            # newElevation = 250
            #
            # testPoint = self.newPtWithInclBear(p1, bearing, inclination, newElevation)


    def calcBearingIncl(self, p1, p2):
        # Convert the bearing angle from degrees to radians
        # Convert the bearing angle from degrees to radians
        # Coordinates of Point 1 (NEE coordinates)


        N1 = float(p1.N)  # Northing in meters
        E1 = float(p1.E)  # Easting in meters
        Elevation1 = float(p1.Z)  # Elevation in meters

        # Coordinates of Point 2 (NEE coordinates)
        N2 = float(p2.N)  # Northing in meters
        E2 = float(p2.E)  # Easting in meters
        Elevation2 = float(p2.Z)  # Elevation in meters

        # Calculate horizontal distance (d)
        d = math.sqrt((E2 - E1)**2 + (N2 - N1)**2)


        # Calculate bearing angle (θ)
        if N2 == N1:
            if E2 > E1:
                bearing = 90  # East
            else:
                bearing = 270  # West
        else:

            bearing = math.atan2(E2 - E1, N2 - N1)
            bearing = math.degrees(bearing)
            if bearing < 0:
                bearing += 360



        # Calculate elevation difference (Δh)
        delta_h = Elevation2 - Elevation1

        # Calculate inclination angle (α) in degrees
        inclination_degrees = math.degrees(math.atan(delta_h / d))

        bearing_deg = bearing

        return bearing_deg, inclination_degrees


    def calcMidPt2d(self, p1org, p3edit):


        middPt = p3edit

        midpoint_N = ((float(p1org.N) + float(p3edit.N)) / 2)
        midpoint_E = ((float(p1org.E) + float(p3edit.E)) / 2)



        middPt.N = midpoint_N
        middPt.E = midpoint_E



        return middPt


    def newPtWithInclBearNewZ(self, pt, inclination_degrees, bearing_degrees, newZ):


        justZ = newZ


        newCalcPoint = types.SimpleNamespace()

        # pt.N = pt.Y
        # pt.E = pt.X
        # p3 förstx
        N1 = float(pt.N)  # Northing in meters
        E1 = float(pt.E)  # Easting in meters
        Z1 = float(pt.Z)
        # NewN = 0
        # NewE = 0


        inc_float = float(inclination_degrees)

        if inc_float > 0:
           pass
        elif inc_float == 0:
           pass
        else:
           inc_float = abs(inc_float) #hmmmmm

        incl_trig = 90-inc_float
        incl_trig_rad = math.radians(incl_trig)

        # ----------
        deltaVert = Z1-newZ
        # deltaVertRikt = None
        # if deltaVert > 0:
        #    deltaVertRikt = "p3 lagre"
        #    VceMessageBox.Show(str(pt)+" - "+str(deltaVertRikt))
        # elif deltaVert == 0:
        #    deltaVertRikt = "p3 samma"
        #    VceMessageBox.Show(str(pt)+" - "+str(deltaVertRikt))
        # else:
        #    deltaVertRikt = "p3 hogre"
        #    VceMessageBox.Show(str(pt)+" - "+str(deltaVertRikt))
        #    deltaVert = abs(deltaVert)



        deltaHor = (math.tan(incl_trig_rad))*deltaVert






        if 0 <= bearing_degrees < 90:
            bear_trig_rad = math.radians(bearing_degrees)
            plusN = (math.cos(bear_trig_rad))*deltaHor
            plusE = (math.sin(bear_trig_rad))*deltaHor
            NewN = N1+float(plusN)
            NewE = E1+float(plusE)
        elif 90 <= bearing_degrees < 180:

            bear_trig = float(bearing_degrees)-90
            bear_trig_rad = math.radians(bear_trig)
            negN = (math.sin(bear_trig_rad))*deltaHor
            plusE = (math.cos(bear_trig_rad))*deltaHor
            NewN = N1-float(negN)
            NewE = E1+float(plusE)
        elif 180 <= bearing_degrees < 270:

            bear_trig = float(bearing_degrees)-180
            bear_trig_rad = math.radians(bear_trig)
            negN = (math.cos(bear_trig_rad))*deltaHor
            negE = (math.sin(bear_trig_rad))*deltaHor
            NewN = N1-float(negN)
            NewE = E1-float(negE)
        elif 270 <= bearing_degrees <= 360:

            bear_trig = float(bearing_degrees)-270
            bear_trig_rad = math.radians(bear_trig)
            plusN = (math.sin(bear_trig_rad))*deltaHor
            negE = (math.cos(bear_trig_rad))*deltaHor
            NewN = N1+float(plusN)
            NewE = E1-float(negE)
        else:
            pass



        newCalcPoint.Y = NewN
        newCalcPoint.X = NewE


        newCalcPoint.N = NewN
        newCalcPoint.E = NewE
        newCalcPoint.Z = justZ
        newCalcPoint.Code = pt.Code
        # VceMessageBox.Show(str(pt.Namn[:-2]))

        newCalcPoint.Namn = pt.Namn[:-2]+"-ber"
        newCalcPoint.Des1 = pt.Des1
        newCalcPoint.Des2 = pt.Des2


        return newCalcPoint



    def newPtWithInclBear(self, pt, bear, incl, newEl):
        # p3 förstx



        newCalcPoint = types.SimpleNamespace()

        N1 = float(pt.N)  # Northing in meters
        E1 = float(pt.E)  # Easting in meters

        inclination_degrees = incl

        inc_float = float(incl)
        if inc_float > 0:
           pass
        elif inc_float == 0:
           pass
        else:
           inclination_degrees = abs(inc_float) #hmmm





        # Coordinates of Point 1 (NEE coordinates)
        # N1 = 2000  # Northing in meters
        # E1 = 1100  # Easting in meters
        Elevation1 = float(pt.Z)  # Elevation in meters

        # Inclination angle from zenith in degrees (negative, as calculated earlier)
        # inclination_degrees = -45.00  # Change this to the desired inclination angle if needed

        # Bearing angle in degrees (270 degrees for westward, as calculated earlier)
        bearing_degrees = bear # Change this to the desired bearing angle if needed

        # Target elevation
        target_elevation = newEl  # Elevation in meters

        # Convert inclination angle to radians
        inclination_radians = math.radians(inclination_degrees)

        # Calculate horizontal distance (d) at the target elevation
        d = (Elevation1 - target_elevation) / math.tan(inclination_radians)

        # Calculate new Northing (N) and Easting (E) at the target elevation
        N = N1 + d * math.cos(math.radians(bearing_degrees))
        E = E1 + d * math.sin(math.radians(bearing_degrees))






        newCalcPoint.N = N
        newCalcPoint.E = E
        newCalcPoint.Z = float(target_elevation)
        newCalcPoint.Code = pt.Code

        newCalcPoint.Namn = pt.Namn[:-2]+"-inm"
        newCalcPoint.Des1 = pt.Des1
        newCalcPoint.Des2 = pt.Des2


        return newCalcPoint






    def findCorPapElevation(self, findName, listPoints):

        valZ = "err"
        for value in listPoints:

            if str(value.Namn) == str(findName):


                valZ = float(value.Z)

        return valZ

    #5 Gör om till rätt inställning i des1 och Des2 m.m.
    def changeDesOneTwo(self, dict):
        #Nollställer global variabel lutningstatus för kontroll
        self.lutBarStatus = "OK"

        #hämtar inställning för decimaler
        decimalerInt = self.getDecimalPlaces()




        if self.lutningInst != "" and self.baringInst != "":
            #gör om lutning till grader
            if self.lutningInst == "Lutningsförhållande":
                try:
                  for key, dictItem in dict.items():
                      dict[key].Des1fullgrad = str(dict[key].Des1)
                      #skapar punkterna i dicten
                      tempDes1 = float(dict[key].Des1)
                      tempDes1rad = math.radians(tempDes1)
                      tan_angle = math.tan(tempDes1rad)
                      #takes float and NOT str
                      tempDes1_rounded = self.getRoundedFloat(tan_angle, decimalerInt)
                      slope_ratio = str(tempDes1_rounded)+":1" #ehhhh
                      full_slope_ratio = str(tan_angle)+":1" #eehhhhh

                      dict[key].Des1 = slope_ratio
                      dict[key].Des1full = full_slope_ratio

                except:
                      self.lutBarStatus = "ERR"


            if self.lutningInst == "Lutningsvinklar grader":
                try:
                  for key, dictItem in dict.items():
                     dict[key].Des1fullgrad = str(dict[key].Des1)
                     tempDes1_float = float(dict[key].Des1)

                     #takes float and NOT str
                     tempDes1_rounded = self.getRoundedFloat(tempDes1_float, decimalerInt)

                     dict[key].Des1 = str(tempDes1_rounded)
                     dict[key].Des1full = str(tempDes1_float)

                except:
                      self.lutBarStatus = "ERR"

            if self.lutningInst == "Lutningsvinklar gon":
                try:
                  for key, dictItem in dict.items():
                      dict[key].Des1fullgrad = str(dict[key].Des1)
                      #skapar punkterna i dicten
                      tempDes1_float = float(dict[key].Des1)*(400/360)
                      tempDes1_rounded = self.getRoundedFloat(tempDes1_float, decimalerInt)
                      dict[key].Des1 = str(tempDes1_rounded)
                      dict[key].Des1full = str(tempDes1_float)

                except:
                      self.lutBarStatus = "ERR"

            if self.lutningInst == "Lutning procent":

                try:
                  for key, dictItem in dict.items():
                      #skapar punkterna i dicten
                      dict[key].Des1fullgrad = str(dict[key].Des1)
                      tempDes1 = float(dict[key].Des1)
                      tempDes1rad = math.radians(tempDes1)
                      slope_percentage_float = math.tan(tempDes1rad) * 100
                      tempDes1_rounded = self.getRoundedFloat(slope_percentage_float, decimalerInt)
                      dict[key].Des1 = str(tempDes1_rounded)+"%"
                      dict[key].Des1full = str(slope_percentage_float)+"%"

                except:
                      self.lutBarStatus = "ERR"




            #gör om BARING till grader
            if self.baringInst == "Grader":
                try:
                  for key, dictItem in dict.items():
                     dict[key].Des2fullgrad = str(dict[key].Des2)
                     tempDes2_float = float(dict[key].Des2)
                     tempDes2_rounded = self.getRoundedFloat(tempDes2_float, decimalerInt)
                     dict[key].Des2 = str(tempDes2_rounded)
                     dict[key].Des2full = str(tempDes2_float)

                except:
                      self.lutBarStatus = "ERR"

            if self.baringInst == "Gon":
                try:
                  for key, dictItem in dict.items():
                      dict[key].Des2fullgrad = str(dict[key].Des2)
                      tempDes2_float = float(dict[key].Des2)*(400/360)
                      tempDes2_rounded = self.getRoundedFloat(tempDes2_float, decimalerInt)
                      dict[key].Des2 = str(tempDes2_rounded)
                      dict[key].Des2full = str(tempDes2_float)

                except:
                      self.lutBarStatus = "ERR"

        # OM FEL
        else:

            self.lutBarStatus = "ERR"

        return dict

    #Returnerar antalet valda decimaler i inställnigarna
    def getDecimalPlaces(self):
        decInt = len(self.deciInst)-2
        return decInt

    #Funktion som avrundar
    def getRoundedFloat(self, float, decimals):

        roundedFloat_zeros = round(float, int(decimals))
        roundedFloat_zeros_str = str(roundedFloat_zeros)
        listSplit = roundedFloat_zeros_str.split(".")

        forePunkt = str(listSplit[0])
        efterPunkt = str(listSplit[1])


        efterPunkt_round = efterPunkt[:decimals]

        rounded_klar_str = forePunkt+"."+efterPunkt_round
        rounded_klar_str_clean = rounded_klar_str.replace(" ", "")


        return rounded_klar_str_clean

    #1 - SKAPAR en lista med punkterna i projektet
    def createListSelectedObjects(self):
        #Selecting alla points
        selectedPoints = []
        #Dessa i-variabler gör förmodligen inget
        i = 0
        str_i = "0"
        for o in self.objs.SelectedMembers(self.currentProject):

            #Kollar om objektet är en punk
            if isinstance(o, self.pType):

                if str(o.Position.X) == "nan" or str(o.Position.Y) == "nan" or str(o.Position.Z) == "nan":
                    pass
                else:

                    punktInfo = types.SimpleNamespace()


                    #Adds id to array
                    if isinstance(o, self.pType):

                        punktInfo.Namn = str(o.PointID)

                    #Adds coordinates
                    if isinstance(o, self.ptType):

                        punktInfo.N = str(o.Position.Y)
                        punktInfo.E = str(o.Position.X)
                        punktInfo.Z = str(o.Position.Z)

                    #Adds featurecode to array
                    if isinstance(o, self.fcType):
                        punktInfo.Code = str(o.FeatureCode)

                    #Adds Description1 to array
                    if hasattr(o, 'Description1'):
                        punktInfo.Des1 = str(o.FullDescription1)

                    #Adds Description1 to array
                    if hasattr(o, 'Description2'):
                        punktInfo.Des2 = str(o.FullDescription2)

                    selectedPoints.insert(i, punktInfo)
                    i = i + 1
            #Skippar om objektet inte är en punkt
            else:
                pass

        return selectedPoints


    #Skapar punkterna
    # Obs!
    # hela macrot anger koordinaterna i NEE. Dock var detta i början
    # så här är det YXZ(omvänt XYZ)
    # Obs!
    def createNewPoint(self, ptObj):

        for o in self.currentProject:

            if isinstance(o, PointManager):
                pm = o

        pnew = Point3D() #OBS!!! TRIMBLE OBJEKT DVS XYZ

        pnew.Y = float(ptObj.N)
        pnew.X = float(ptObj.E)
        pnew.Z = float(ptObj.Z)

        pnew_wv = CoordPoint.CreatePoint(self.currentProject, str(ptObj.Namn))

        pnew_wv.Description1 = str(ptObj.Des1)
        pnew_wv.Description2 = str(ptObj.Des2)

        fCode = ptObj.Code

        if fCode == "":
            pm.SetFeatureCodeAtPoint(pnew_wv.SerialNumber, "")
        else:
            pm.SetFeatureCodeAtPoint(pnew_wv.SerialNumber, str(ptObj.Code))


        pnew_wv.AddPosition(pnew)
